Leetcode 486. Predict the Winner

486. Predict the Winner

Description

Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a number, that number will not be available for the next player. This continues until all the scores have been chosen. The player with the maximum score wins.

Given an array of scores, predict whether player 1 is the winner. You can assume each player plays to maximize his score.

Example 1:

Input: [1, 5, 2]
Output: False
Explanation: Initially, player 1 can choose between 1 and 2. 
If he chooses 2 (or 1), then player 2 can choose from 1 (or 2) and 5. If player 2 chooses 5, then player 1 will be left with 1 (or 2). 
So, final score of player 1 is 1 + 2 = 3, and player 2 is 5. 
Hence, player 1 will never be the winner and you need to return False.

Example 2:

Input: [1, 5, 233, 7]
Output: True
Explanation: Player 1 first chooses 1. Then player 2 have to choose between 5 and 7. No matter which number player 2 choose, player 1 can choose 233.
Finally, player 1 has more score (234) than player 2 (12), so you need to return True representing player1 can win.

Note:

  1. 1 <= length of the array <= 20.
  2. Any scores in the given array are non-negative integers and will not exceed 10,000,000.
  3. If the scores of both players are equal, then player 1 is still the winner.

Solution

两个人轮流从开始或结尾选取数字,当全部选完后,得分最高的获胜,如果两者相同,则玩家一获胜。

每个玩家都以最优的方式选择,所以需要判断选择开始或者结束。假如选择开始,那么另一个玩家就能从剩下部分里面选择对自己最优的值;选择结尾,情况也是一样。所以,有如下判断条件

max(nums[start] - dp[start+1][end], nums[end] - dp[start][end-1])

当结果大于等于 0 时,玩家一就能够取胜。

class Solution {
public:
    bool PredictTheWinner(vector<int>& nums) {
        int size = nums.size();
        if (size <= 1) {
            return true;
        }
        
        memo_.resize(size, vector<int>(size, 0));
        helper(nums, 0, size-1);
        return memo_[0][size-1] >= 0;
    }
    
private:
    int helper(vector<int>& nums, int l, int r) {
        if (l == r) {
            return nums[l];
        }
        
        if (memo_[l][r] == 0) {
            // selected best chooice
            memo_[l][r] = max(
                nums[l] - helper(nums, l+1, r), 
                nums[r] - helper(nums, l, r-1)
            );
        }
        
        return memo_[l][r];
    }
    
    vector<vector<int>> memo_;
};

猜你喜欢

转载自www.cnblogs.com/wuhanqing/p/9398933.html